(document:surround "/std/frame")

;;;;;;;;;;;;;;;;;;;;;;

(define (apply-data url really)
    (woo-write url
        'commit really
        'monitor (monitor value)
        'xdepth (depth value)
        'xresolution (resolution value)))

(define (test-not-apply)
  (woo-catch/message
   (thunk (apply-data "/x11" #f)
          (woo-write "/x11/test"))))

;; save data if url changed
(define (change url)
  (apply-data "/x11" #f)
  (frame:replace url))

;;;;;;;;;;;;;;;;;;;;;;;;; ui

(document:id config-x11 (checkbox state #f visibility #f))
(gridbox 
  columns "10;0;80;10"
  ;;
  (spacer)
  (label text (bold (_ "Detected hardware")) align "right")
  (spacer)
  (spacer)

  ;;
  (spacer)
  (label text (_ "Video card:") align "right")
  (document:id auto-card (label))
  (spacer)

  ;;
  (spacer)
  (label text (_ "Monitor:") align "right")
  (document:id auto-monitor (label))
  (spacer)

  ;;
  (spacer)
  (separator colspan 2)
  (spacer)

  ;;
  (spacer)
  (label text (bold (_ "Current settings")) align "right")
  (spacer)
  (spacer)

  ;;
  (spacer)
  (label text (_ "Monitor:") align "right")
  (hbox
    align "left"
    (document:id monitor (combobox))
    (document:id ch-mon (button text (_ "Other vendor..."))))
  (spacer)

  ;;
  (spacer)
  (label text (_ "Driver:") align "right")
  (hbox
    align "left"
    (document:id driver (label))
    (document:id ch-drv (button text (_ "Other driver..."))))
  (spacer)

  ;;
  (spacer)
  (label text (_ "Color depth:") align "right")
  (document:id depth (combobox align "left"))
  (spacer)

  ;;
  (spacer)
  (label text (_ "Resolution:") align "right")
  (document:id resolution (combobox align "left"))
  (spacer)

  ;;
  (label colspan 4)

  ;;
  (spacer)
  (spacer)
  (hbox
    align "left"
    (button text (_ "Test")
	    (when clicked (test-not-apply)))
    (or (global 'frame:next-button)
	(button text (_ "Apply")
		(when clicked (apply-data "/x11" #t))))
    (document:id quit-btn 
      (button text (_ "Quit") visibility #f
        (when clicked (document:end)))))
  (spacer))

;;;;;;;;;;;;;;;;;;; actions
(ch-mon (when clicked (change "/x11/monitor")))
(ch-drv (when clicked (change "/x11/driver")))

;;;;;;;;;;;;;;;;;;; installer specific
(frame:on-next (thunk (or (apply-data "/x11" #t) 'cancel)))

(document:root
  (when loaded
    (woo-catch/message
      (thunk
        (let ((data (woo-read-first "/x11")))
            (auto-card text (woo-get-option data 'auto_cardname))
            (auto-monitor text (woo-get-option data 'auto_monitor))
            (driver text (woo-get-option data 'xdrivername ""))
            (quit-btn visibility (woo-get-option data 'config_x11 #f))
            (monitor enumref "/x11/avail_model"
                     value (woo-get-option data 'monitor ""))
	    (resolution enumref "/x11/avail_xresolution"
		        value (woo-get-option data 'xresolution ""))
	    (depth enumref "/x11/avail_xdepth"
	           value (woo-get-option data 'xdepth "")))))))
